Screen                  EQU #C000                       ;
ULA                     EQU #7F00                       ;

PIOa                    EQU #F400                       ;
PIOb                    EQU #F500                       ;
PIOc                    EQU #F600                       ;
PIOk                    EQU #F700                       ;

IntVector               EQU #38                         ;
;
Del                     EQU #8                          ;
Cls                     EQU #C                          ;
Cret                    EQU #D                          ;
Clr                     EQU #18                         ;
;
ColA                    EQU 2                           ;
ColB                    EQU 3                           ;
ColC                    EQU 4                           ;
Blank                   EQU 1                           ;
;
HSTimeOut               EQU #6000                       ;
FlashRate               EQU #140                        ;
;
HighScores              EQU #800                        ;
;
RepSpeed1               EQU 100                         ;
RepSpeed2               EQU 13                          ;
CurFR                   EQU 80                          ;
UDKfr                   EQU 180                         ;
;
pScore                  equ Screen+24*80                ;
pBarAddr                equ pScore+16+$800              ;

;
sdT                     equ $3D                         ;
sdN                     equ $2F                         ;
sdNT                    equ $2D                         ;

;            Internals
;
SubptX                  EQU 0                           ;
SubptZ                  EQU 2                           ;
;
PlanX                   EQU 0                           ;
PlanY                   EQU 2                           ;
;
Workspace               EQU #A000                       ;
;

                        ORG $0400 - 6*8                 ;

; Chars
pChars                  EQU * - $D0                     ;

                        dg -#####--                     ;
                        dg #-----#-                     ;
                        dg #--##-#-                     ;
                        dg #-#---#-                     ;
                        dg #--##-#-                     ;
                        dg #-----#-                     ;
                        dg -#####--                     ;
                        dg --------                     ;

                        dg --##----                     ;
                        dg -#--#---                     ;
                        dg -#------                     ;
                        dg ###-----                     ;
                        dg -#------                     ;
                        dg -#--#---                     ;
                        dg #####---                     ;
                        dg --------                     ;

                        dg --#-----                     ;
                        dg -###----                     ;
                        dg #-#-#---                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg ----#---                     ;
                        dg -----#--                     ;
                        dg #######-                     ;
                        dg -----#--                     ;
                        dg ----#---                     ;
                        dg --------                     ;

                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg #-#-#---                     ;
                        dg -###----                     ;
                        dg --#-----                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg --#-----                     ;
                        dg -#------                     ;
                        dg #######-                     ;
                        dg -#------                     ;
                        dg --#-----                     ;
                        dg --------                     ;


                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;

                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg --------                     ;
                        dg #-------                     ;
                        dg --------                     ;

                        dg #-#-----                     ;
                        dg #-#-----                     ;
                        dg #-#-----                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;

                        dg -#-#----                     ;
                        dg -#-#----                     ;
                        dg #####---                     ;
                        dg -#-#----                     ;
                        dg #####---                     ;
                        dg -#-#----                     ;
                        dg -#-#----                     ;
                        dg --------                     ;

                        dg --#-----                     ;
                        dg -####---                     ;
                        dg #-#-----                     ;
                        dg -###----                     ;
                        dg --#-#---                     ;
                        dg ####----                     ;
                        dg --#-----                     ;
                        dg --------                     ;

                        dg ##------                     ;
                        dg ##--#---                     ;
                        dg ---#----                     ;
                        dg --#-----                     ;
                        dg -#------                     ;
                        dg #--##---                     ;
                        dg ---##---                     ;
                        dg --------                     ;

                        dg -#------                     ;
                        dg #-#-----                     ;
                        dg #-#-----                     ;
                        dg -#------                     ;
                        dg #-#-#---                     ;
                        dg #--#----                     ;
                        dg -##-#---                     ;
                        dg --------                     ;

                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;

                        dg --#-----                     ;
                        dg -#------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg -#------                     ;
                        dg --#-----                     ;
                        dg --------                     ;

                        dg #-------                     ;
                        dg -#------                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg -#------                     ;
                        dg #-------                     ;
                        dg --------                     ;

                        dg --#-----                     ;
                        dg #-#-#---                     ;
                        dg -###----                     ;
                        dg --#-----                     ;
                        dg -###----                     ;
                        dg #-#-#---                     ;
                        dg --#-----                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg #####---                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --------                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg #-------                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg #####---                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg #-------                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg ----#---                     ;
                        dg ---#----                     ;
                        dg --#-----                     ;
                        dg -#------                     ;
                        dg #-------                     ;
                        dg --------                     ;
                        dg --------                     ;

; Chars

                        dg -###----                     ;
                        dg #---#---                     ;
                        dg #--##---                     ;
                        dg #-#-#---                     ;
                        dg ##--#---                     ;
                        dg #---#---                     ;
                        dg -###----                     ;
                        dg --------                     ;

                        dg --#-----                     ;
                        dg -##-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg -###----                     ;
                        dg --------                     ;

                        dg -###----                     ;
                        dg #---#---                     ;
                        dg ----#---                     ;
                        dg --##----                     ;
                        dg -#------                     ;
                        dg #-------                     ;
                        dg #####---                     ;
                        dg --------                     ;

                        dg #####---                     ;
                        dg ----#---                     ;
                        dg ---#----                     ;
                        dg --##----                     ;
                        dg ----#---                     ;
                        dg #---#---                     ;
                        dg -###----                     ;
                        dg --------                     ;

                        dg ---#----                     ;
                        dg --##----                     ;
                        dg -#-#----                     ;
                        dg #--#----                     ;
                        dg #####---                     ;
                        dg ---#----                     ;
                        dg ---#----                     ;
                        dg --------                     ;

                        dg #####---                     ;
                        dg #-------                     ;
                        dg ####----                     ;
                        dg ----#---                     ;
                        dg ----#---                     ;
                        dg #---#---                     ;
                        dg -###----                     ;
                        dg --------                     ;

                        dg --###---                     ;
                        dg -#------                     ;
                        dg #-------                     ;
                        dg ####----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -###----                     ;
                        dg --------                     ;

                        dg #####---                     ;
                        dg ----#---                     ;
                        dg ---#----                     ;
                        dg --#-----                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg --------                     ;

                        dg -###----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -###----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -###----                     ;
                        dg --------                     ;

                        dg -###----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -####---                     ;
                        dg ----#---                     ;
                        dg ---#----                     ;
                        dg ###-----                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg #-------                     ;
                        dg --------                     ;
                        dg #-------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg -#------                     ;
                        dg --------                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg #-------                     ;
                        dg --------                     ;

                        dg ---#----                     ;
                        dg --#-----                     ;
                        dg -#------                     ;
                        dg #-------                     ;
                        dg -#------                     ;
                        dg --#-----                     ;
                        dg ---#----                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg #####---                     ;
                        dg --------                     ;
                        dg #####---                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;

                        dg #-------                     ;
                        dg -#------                     ;
                        dg --#-----                     ;
                        dg ---#----                     ;
                        dg --#-----                     ;
                        dg -#------                     ;
                        dg #-------                     ;
                        dg --------                     ;

                        dg -###----                     ;
                        dg #---#---                     ;
                        dg ---#----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --------                     ;
                        dg --#-----                     ;
                        dg --------                     ;

; Chars

                        dg -###----                     ;
                        dg #---#---                     ;
                        dg #-#-#---                     ;
                        dg #-###---                     ;
                        dg #-##----                     ;
                        dg #-------                     ;
                        dg -####---                     ;
                        dg --------                     ;

                        dg --#-----                     ;
                        dg -#-#----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #####---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg --------                     ;

                        dg ####----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg ####----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg ####----                     ;
                        dg --------                     ;

                        dg -###----                     ;
                        dg #---#---                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #---#---                     ;
                        dg -###----                     ;
                        dg --------                     ;

                        dg ####----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg ####----                     ;
                        dg --------                     ;

                        dg #####---                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg ####----                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #####---                     ;
                        dg --------                     ;

                        dg #####---                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg ####----                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg --------                     ;

                        dg -####---                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #--##---                     ;
                        dg #---#---                     ;
                        dg -####---                     ;
                        dg --------                     ;

                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #####---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg --------                     ;

                        dg ###-----                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg ###-----                     ;
                        dg --------                     ;

                        dg ----#---                     ;
                        dg ----#---                     ;
                        dg ----#---                     ;
                        dg ----#---                     ;
                        dg ----#---                     ;
                        dg #---#---                     ;
                        dg -###----                     ;
                        dg --------                     ;

                        dg #---#---                     ;
                        dg #--#----                     ;
                        dg #-#-----                     ;
                        dg ##------                     ;
                        dg #-#-----                     ;
                        dg #--#----                     ;
                        dg #---#---                     ;
                        dg --------                     ;

                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #####---                     ;
                        dg --------                     ;

                        dg #---#---                     ;
                        dg ##-##---                     ;
                        dg #-#-#---                     ;
                        dg #-#-#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg --------                     ;

                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg ##--#---                     ;
                        dg #-#-#---                     ;
                        dg #--##---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg --------                     ;

                        dg -###----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -###----                     ;
                        dg --------                     ;

; Chars

                        dg ####----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg ####----                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg --------                     ;

                        dg -###----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #-#-#---                     ;
                        dg #--#----                     ;
                        dg -##-#---                     ;
                        dg --------                     ;

                        dg ####----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg ####----                     ;
                        dg #-#-----                     ;
                        dg #--#----                     ;
                        dg #---#---                     ;
                        dg --------                     ;

                        dg -###----                     ;
                        dg #---#---                     ;
                        dg #-------                     ;
                        dg -###----                     ;
                        dg ----#---                     ;
                        dg #---#---                     ;
                        dg -###----                     ;
                        dg --------                     ;

                        dg #####---                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --------                     ;

                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -###----                     ;
                        dg --------                     ;

                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -#-#----                     ;
                        dg --#-----                     ;
                        dg --------                     ;

                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #-#-#---                     ;
                        dg #-#-#---                     ;
                        dg ##-##---                     ;
                        dg #---#---                     ;
                        dg --------                     ;

                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -#-#----                     ;
                        dg --#-----                     ;
                        dg -#-#----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg --------                     ;

                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -#-#----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --------                     ;

                        dg #####---                     ;
                        dg ----#---                     ;
                        dg ---#----                     ;
                        dg --#-----                     ;
                        dg -#------                     ;
                        dg #-------                     ;
                        dg #####---                     ;
                        dg --------                     ;

                        dg #####---                     ;
                        dg ##------                     ;
                        dg ##------                     ;
                        dg ##------                     ;
                        dg ##------                     ;
                        dg ##------                     ;
                        dg #####---                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg #-------                     ;
                        dg -#------                     ;
                        dg --#-----                     ;
                        dg ---#----                     ;
                        dg ----#---                     ;
                        dg --------                     ;
                        dg --------                     ;

                        dg #####---                     ;
                        dg ---##---                     ;
                        dg ---##---                     ;
                        dg ---##---                     ;
                        dg ---##---                     ;
                        dg ---##---                     ;
                        dg #####---                     ;
                        dg --------                     ;

                        dg --#-----                     ;
                        dg -###----                     ;
                        dg #-#-#---                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --------                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg #####---                     ;
                        dg --------                     ;

; Chars

                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg -##-#---                     ;
                        dg #--##---                     ;
                        dg #---#---                     ;
                        dg #--##---                     ;
                        dg -##-#---                     ;
                        dg --------                     ;

                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-##----                     ;
                        dg ##--#---                     ;
                        dg #---#---                     ;
                        dg ##--#---                     ;
                        dg #-##----                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg -####---                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg -####---                     ;
                        dg --------                     ;

                        dg ----#---                     ;
                        dg ----#---                     ;
                        dg -##-#---                     ;
                        dg #--##---                     ;
                        dg #---#---                     ;
                        dg #--##---                     ;
                        dg -##-#---                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg -###----                     ;
                        dg #---#---                     ;
                        dg #####---                     ;
                        dg #-------                     ;
                        dg -###----                     ;
                        dg --------                     ;

                        dg --#-----                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg ###-----                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg -####---                     ;
                        dg #---#---                     ;
                        dg #--##---                     ;
                        dg -##-#---                     ;
                        dg ----#---                     ;
                        dg -###----                     ;

                        dg #-------                     ;
                        dg #-------                     ;
                        dg ####----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg --------                     ;

                        dg #-------                     ;
                        dg --------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --#-----                     ;
                        dg --------                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg ##------                     ;

                        dg #-------                     ;
                        dg #-------                     ;
                        dg #--#----                     ;
                        dg #-#-----                     ;
                        dg ###-----                     ;
                        dg #--#----                     ;
                        dg #---#---                     ;
                        dg --------                     ;

                        dg ##------                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg ###-----                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg ##-#----                     ;
                        dg #-#-#---                     ;
                        dg #-#-#---                     ;
                        dg #-#-#---                     ;
                        dg #-#-#---                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg ####----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg -###----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -###----                     ;
                        dg --------                     ;

; Chars

                        dg --------                     ;
                        dg --------                     ;
                        dg ####----                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg ####----                     ;
                        dg #-------                     ;
                        dg #-------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg -####---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -####---                     ;
                        dg ----#---                     ;
                        dg ----#---                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg #-##----                     ;
                        dg ##------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg -####---                     ;
                        dg #-------                     ;
                        dg -###----                     ;
                        dg ----#---                     ;
                        dg ####----                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --#-----                     ;
                        dg #####---                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg ---##---                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -####---                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg -#-#----                     ;
                        dg -#-#----                     ;
                        dg --#-----                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #---#---                     ;
                        dg #-#-#---                     ;
                        dg -#-#----                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg #---#---                     ;
                        dg -#-#----                     ;
                        dg --#-----                     ;
                        dg -#-#----                     ;
                        dg #---#---                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg #--#----                     ;
                        dg #--#----                     ;
                        dg #--#----                     ;
                        dg ####----                     ;
                        dg ---#----                     ;
                        dg ###-----                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg #####---                     ;
                        dg ---#----                     ;
                        dg --#-----                     ;
                        dg -#------                     ;
                        dg #####---                     ;
                        dg --------                     ;

                        dg --##----                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg #-------                     ;
                        dg -#------                     ;
                        dg -#------                     ;
                        dg --##----                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg #-------                     ;
                        dg #-------                     ;
                        dg --------                     ;

                        dg ##------                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg ---#----                     ;
                        dg --#-----                     ;
                        dg --#-----                     ;
                        dg ##------                     ;
                        dg --------                     ;

                        dg -#-#----                     ;
                        dg #--#----                     ;
                        dg -###----                     ;
                        dg #---#---                     ;
                        dg #####---                     ;
                        dg #-------                     ;
                        dg -###----                     ;
                        dg --------                     ;

                        dg --------                     ;
                        dg --------                     ;
                        dg ----#---                     ;
                        dg -###----                     ;
                        dg #-------                     ;
                        dg --------                     ;
                        dg --------                     ;
                        dg --------                     ;

wChars                  DEFB $00,$00,$00,$00,$00,$00,$00,$00; ........
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00; ........
                        DEFB $00,$00,$00,$00,$00,$00,$00,$00; ........
                        DEFB $00,$00,$08,$06,$06,$08,$06,$08; ........
                        DEFB $06,$02,$04,$06,$06,$06,$06,$02; ........
                        DEFB $04,$04,$06,$06,$03,$06,$02,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$02,$03,$05,$06,$05,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$04,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$04,$06; ........
                        DEFB $06,$02,$04,$06,$04,$06,$06,$06; ........
                        DEFB $06,$06,$05,$06,$06,$06,$06,$06; ........
                        DEFB $06,$05,$06,$05,$02,$05,$06,$06; ........
                        DEFB $03,$06,$0C,$12,$18,$1E,$24,$2A; ......$*
                        DEFB $30,$36,$3C,$42,$48,$06,$06,$06; 06<BH...
                        DEFB $01,$02,$03,$04,$05,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$96,$06,$06,$06,$06,$06,$06; ........
                        DEFB $06,$06,$06,$06,$06,$06,$06,$00; ........

HighScores              DEFB "I'm feeling so alone now",$00,$01,$00;
                        DEFB "They cut the telephone uh huh",$00,$01,$00;
                        DEFB "Yeah my life is just a mess",$00,$01,$00;
                        DEFB " ",$00,$01,$00,"I threw it all away now",$00,$01,$00;
                        DEFB "I could have made a fortune",$00,$01,$00;
                        DEFB "I lost the craving for success",$00,$01,$00;
                        DEFB " ",$00,$01,$00,"And as the acrobats they tumble",$00,$01,$00;
                        DEFB "So the corn begins to crumble",$00,$01,$00;
                        DEFB "While in the mirror",$00,$01,$00,"She admires a brand new dr";
                        DEFB "ess",$00,$01,$00," ",$00,$01,$00,"CD-3708",$00,$01,$00;
                        DEFB " ",$00,$01,$00,"Who are Linn Products anyway?",$00,$01,$00;
                        DEFB "!",$00,$FF,$FF            ;

                        align $100                      ;

                        DEFB "Design Design Software",$00,$01,$00;
                        DEFB " What a what a silly silly name!",$00,$01,$00;
                        DEFB "Chewrubba",$00,$01,$00," ",$22,"Hello little girl",$22,$00,$01,$00;
                        DEFB "Corwench",$00,$01,$00," ",$22,"Hello large hairy programmer!",$22,$00,$01,$00;
                        DEFB "Psi",$00,$01,$00," ",$22,"Baaaa! I'm going to Wrexham!",$22,$00,$01,$00;
                        DEFB "Indiana Mott",$00,$01,$00," ",$22,"I'll bite your ankles!",$22,$00,$01,$00;
                        DEFB "I Nig'Em",$00,$01,$00," ",$22,"How awful!",$22,$00,$01,$00;
                        DEFB "Wookiee",$00,$01,$00," ",$22,"Get your hands off my ears! Mon!",$22,$00;
                        DEFB $01,$00,"Only one thing remains to say...",$00,$01,$00;
                        DEFB "Who is Rainbow Software anyway?",$00,$01,$00;
                        DEFB "!",$00,$FF,$FF            ;

                        align $100                      ;

                        DEFB " This programme was not written using OS-9",$00,$01,$00;
                        DEFB "and any resemblance to Rommels - living or",$00,$01,$00;
                        DEFB "dead - is purely coincidental, and nothing",$00,$01,$00;
                        DEFB "whatever to do with the fact that Wookiee",$00,$01,$00;
                        DEFB "- who lives next door - leaves his Rommels",$00,$01,$00;
                        DEFB "source files lying around in a big friendly-",$00,$01,$00;
                        DEFB "looking black folder about which I know",$00,$01,$00;
                        DEFB "absolutely nothing.",$00,$01,$00," ",$00,$01,$00;
                        DEFB " Well, OK, I admit I've seen it on his floor",$00,$01;
                        DEFB $00,"but I'd never open it - perish the thought!",$00,$01,$00;
                        DEFB "and if it did fall open that time I accidently",$00,$01;
                        DEFB $00,"knocked it off the table, well, you know I",$00,$01,$00;
                        DEFB "would never have READ any of it, not me, I",$00,$01,$00;
                        DEFB "wouldn't do that. OK - so I made a few notes.",$00;
                        DEFB $01,$00,"Where's the harm? They were only little ones...";
                        DEFB $00,$01,$00,"!",$00,$FF,$FF;
; Fixed data
                        org $1000                       ;
AType                   ds 1                            ;
BType                   ds 1                            ;
CType                   ds 1                            ;
DType                   ds 1                            ;
EType                   ds 1                            ;

KeyTab                  ds 21                           ;
ShiftKey                ds 2                            ;
CtrlKey                 ds 47                           ;
CapsKey                 ds 10                           ;

KeyCodes                DEFB $1C,$1D,$1E,$39,$36,$33,$0D,$2E
                        DEFB $1F,$1A,$37,$38,$35,$31,$32,$30
                        DEFB $18,$5B,$0D,$5D,$34,$2E,$5C,$2E
                        DEFB $5E,$2D,$40,$50,$3B,$3A,$2F,$2E
                        DEFB $30,$39,$4F,$49,$4C,$4B,$4D,$2C
                        DEFB $38,$37,$55,$59,$48,$4A,$4E,$20
                        DEFB $36,$35,$52,$54,$47,$46,$42,$56
                        DEFB $34,$33,$45,$57,$53,$44,$43,$58
                        DEFB $31,$32,$17,$51,$2E,$41,$2E,$5A
                        DEFB $2E,$2E,$2E,$2E,$2E,$2E,$2E,$08
                        DEFB $1C,$1D,$1E,$39,$36,$33,$0D,$2E
                        DEFB $1F,$1A,$37,$38,$35,$31,$32,$30
                        DEFB $18,$7B,$0D,$7D,$34,$2E,$5C,$2E
                        DEFB $1B,$3D,$7C,$70,$2B,$2A,$3F,$3E
                        DEFB $5F,$29,$6F,$69,$6C,$6B,$6D,$3C
                        DEFB $28,$27,$75,$79,$68,$6A,$6E,$20
                        DEFB $26,$25,$72,$74,$67,$66,$62,$76
                        DEFB $24,$23,$65,$77,$73,$64,$63,$78
                        DEFB $21,$22,$17,$71,$19,$61,$2E,$7A
                        DEFB $2E,$2E,$2E,$2E,$BE,$2E,$2E,$08

UDKdesc                 DEFB $82,$1C,$82,$1D,$82,$1E,$82,$39
                        DEFB $82,$36,$82,$33,$82,$C5,$EE,$74
                        DEFB $82,$2E,$82,$1F,$82,$C3,$EF,$F0
                        DEFB $79,$82,$37,$82,$38,$82,$35,$82
                        DEFB $31,$82,$32,$82,$30,$C3,$EC,$72
                        DEFB $5B,$C5,$EE,$74,$5D,$82,$34,$D3
                        DEFB $E8,$E9,$E6,$74,$5C,$C3,$F4,$F2
                        DEFB $6C,$5E,$2D,$40,$50,$3B,$3A,$2F
                        DEFB $2E,$30,$39,$4F,$49,$4C,$4B,$4D
                        DEFB $2C,$38,$37,$55,$59,$48,$4A,$4E
                        DEFB $D3,$F0,$E1,$E3,$65,$36,$35,$52
                        DEFB $54,$47,$46,$42,$56,$34,$33,$45
                        DEFB $57,$53,$44,$43,$58,$31,$32,$C5
                        DEFB $F3,$63,$51,$D4,$E1,$62,$41,$C3
                        DEFB $E1,$70,$5A,$83,$1C,$83,$1E,$83
                        DEFB $1F,$83,$1D,$83,$C6,$E9,$F2,$65
                        DEFB $83,$3F,$83,$3F,$C4,$E5,$6C

iUDKTab                 DEFB $4A,$47,$08,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$4B
                        DEFB $3F,$01,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$48
                        DEFB $2E,$00,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$49
                        DEFB $26,$02,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$4C
                        DEFB $45,$3C,$3D,$35,$34,$2F,$09,$FF
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$12
                        DEFB $1D,$24,$25,$2D,$2C,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$4F
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$70
                        DEFB $00,$00,$00
UDKTab                  DEFB $4A,$47,$08,$FF,$FF
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$4B,$3F,$01,$FF,$FF
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$48,$2E,$00,$FF,$FF
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$49,$26,$02,$FF,$FF
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$4C,$45,$3C,$3D,$35
                        DEFB $34,$2F,$09,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$12,$1D,$24,$25,$2D
                        DEFB $2C,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$4F,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
                        DEFB $FF,$FF,$FF                ;

pcPall                  DEFW 0                          ;
pCurY                   DEFW 0                          ;
pCurX                   DEFW 0                          ;
ppCurY                  DEFB 0                          ;
;
                        DEFS 3                          ;

ukLeft                  ds 3
ukRight                 ds 3
ukForward               ds 3
ukBackward              ds 3
ukFire                  ds 3
ukFireMiss              ds 3
ukExit                  ds 3

KeyWorkspace            defs 7*5*11                     ;
KeyBuffer               defs 10                         ;

pSt                     equ low cStart                  ;
pZ                      equ low ScZero                  ;

ScoreData               db pSt,pSt,pSt                  ;
                        db pSt,pSt,pSt                  ;
                        db pSt,pSt,pSt                  ;
                        db pSt,pSt,pSt                  ;
                        db pZ,pZ,pZ                     ;

pCl                     equ Screen+24*80+80-$10         ;
pArrow                  equ pCl-4                       ;

ClockData               dw cStart,cStart,cStart         ;
                        dw cStart,cStart,cStart         ;
                        dw pCl+$E,pCl+$C,pCl+$8         ;
                        dw pCl+$6,pCl+$2,pCl+$0         ;
                        db 9,5,9,5,9,9                  ;

Colon1                  equ pCl+$4+$1000                ;
Colon2                  equ pCl+$A+$1000                ;

Slice                   db 0                            ;
SecCount                db 0                            ;
SSc                     db 0                            ;
SSpU                    dw 0                            ;
SSpD                    dw 0                            ;
AScore                  dw 0                            ;
ScoreBuff               ds 15                           ;
p1                      ds 12                           ;
FirstpDig               ds 12                           ;
FirstDig                ds 6                            ;
ColonF                  db 0                            ;
FSHL                    dw 0                            ;

AEnergy                 db 0                            ;
pBar                    dw Screen                       ;
BarBit                  db $11                          ;

                        ORG Workspace                   ;
;
DivTab                  DEFS #100                       ;
XDivTab                 DEFS #100                       ;
YTable                  DEFS #200                       ;
;
CentX                   DEFS 2                          ;
CentY                   DEFS 2                          ;
CentZ                   DEFS 2                          ;
;
DispAng                 DEFS 1                          ;
;
DScore                  DEFS 2                          ;
DEnergy                 DEFS 2                          ;
                        ;

                        DEFS #40                        ;
                        DEFS 16*90                      ;
OldLines1               DEFS #42                        ;
                        DEFS 16*90                      ;
OldLines2               DEFS #42                        ;
;
MntStore1               DEFS 320                        ;
                        DEFS #40                        ;
MntStore2               DEFS 320                        ;

                        nop

